apiVersion: v1
kind: Namespace
metadata:
  name: gitlab-agent # {"$openapi":"namespace"}
---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: gitlab-agent
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: gitlab-agent
spec:
  replicas: 1
  selector:
    matchLabels:
      app: gitlab-agent
  template:
    metadata:
      labels:
        app: gitlab-agent
      annotations:
        prometheus.io/scrape: "true" # {"$openapi":"prometheus-scrape"}
        prometheus.io/path: "/metrics"
        prometheus.io/port: "8080"
    spec:
      serviceAccountName: gitlab-agent
      containers:
      - name: agent
        image: "registry.gitlab.com/gitlab-org/cluster-integration/gitlab-agent/agentk:v14.5.0-rc2" # {"$openapi":"agent-version-subst"}
        args:
        - --token-file=/config/token
        - --kas-address
        - wss://kas.gitlab.com # {"$openapi":"kas-address"}
        # - grpc://host.docker.internal:8150 # use this when connecting from within Docker e.g. from kind
        volumeMounts:
        - name: token-volume
          mountPath: /config
        env:
        - name: POD_NAMESPACE
          valueFrom:
            fieldRef:
              fieldPath: metadata.namespace
        - name: POD_NAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        readinessProbe:
          httpGet:
            path: "/readiness"
            port: 8080
          initialDelaySeconds: 5
          periodSeconds: 10
        livenessProbe:
          httpGet:
            path: "/liveness"
            port: 8080
          initialDelaySeconds: 15
          periodSeconds: 20
      volumes:
      - name: token-volume
        secret:
          secretName: gitlab-agent-token
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 0
      maxUnavailable: 1
